if ( not SpellCast_Tooltip ) then	-- SpellCast UTILITY DEFINITION

SpellCast_inProgress		= nil	-- What is the spell being cast right now?
SpellCast_inProgressList	= {}	-- What other spells are being cast right now?

local utility	= CreateFrame( "GameTooltip", "SpellCast_Tooltip", WorldFrame, "GameTooltipTemplate" )
utility:SetOwner( UIParent, "ANCHOR_NONE" )

local events	= {}
utility.events	= events
utility:RegisterEvent( "UNIT_SPELLCAST_SENT" )

utility:SetScript( "OnEvent",
	function(self, event, unit, spellName, rank, target)
		if ( unit == 'player' ) then
			assert( "SpellCast.OnEvent", event, spellName, rank, target )
			self.events[ event ]( self, spellName, rank, target )
		end
	end
)

-- An interesting function: UnitCastingInfo( 'player' ).  Research later.

events.UNIT_SPELLCAST_SENT	= function(self, spellName, rank, target)
	local spell	= {	target	= target	}
	spell.ID, spell.book, spell.name, spell.rank	= GetSpellByName( spellName, rank )
	
	if ( spell.ID ) then
		assert( "SpellCast.SENT", spell )
		tinsert( SpellCast_inProgressList, spell )
		SpellCast_inProgress	= spell

		self:RegisterEvent( "UNIT_SPELLCAST_INTERRUPTED" )
		self:RegisterEvent( "UNIT_SPELLCAST_SUCCEEDED" )
		
	else
		assert( "SpellCast.SENT", "ignored." )
		SpellCast_ignored	= spell
	end
end

events.UNIT_SPELLCAST_INTERRUPTED	= function(self)
	SpellCast_last			= tremove( SpellCast_inProgressList, 1 )
	SpellCast_inProgress	= SpellCast_inProgressList[1]

	self:UnregisterEvent( "UNIT_SPELLCAST_INTERRUPTED" )
	self:UnregisterEvent( "UNIT_SPELLCAST_SUCCEEDED" )
end
events.UNIT_SPELLCAST_SUCCEEDED	= events.UNIT_SPELLCAST_INTERRUPTED

end	-- SpellCast UTILITY DEFINITION

